import { APIClient, APIResponse, type AuthStoreType } from './base'

const BASE_URL = import.meta.env.VITE_API_URL + '/auth'

export interface User {
  id: number
  username: string
  createdAt: number
  isLocked: boolean
  isAdmin: boolean
}

export class AuthenticationAPIClient extends APIClient {
  constructor(authStore: AuthStoreType) {
    super(BASE_URL, authStore)
  }

  login(username: string, password: string): APIResponse<User> {
    const promise = fetch(this.baseUrl + '/login', {
      method: 'POST',
      headers: {
        Authorization: 'Basic ' + btoa(username + ':' + password),
      },
    })
    return new APIResponse(this.handleAPIResponse(promise))
  }
}
